//----------------------------------------------------------------------------------
//		k΍@NbvtB^
//----------------------------------------------------------------------------------

/**********************************************************************
	ڎ
	EOu
		E萔
		EO[oϐ
		Egf[^
		E֐̃vg^Cv
	E
		EgbNo[ݒ
		EtB^\̒`
		EtB^\̂̃|C^n֐
	Egf[^̈恨tB^
		EtB^֐(func_proc)
		ElanczosTCY
	Eݒʁgf[^̈
		Eݒ肪ύXꂽƂɌĂ΂֐(func_update)
		EAXyNgێ
		EenumIG֐
		EݒEBhEɃEBhEbZ[WɌĂ΂֐(func_WndProc)
**********************************************************************/

//---------------------------------------------------------------------
//		萔
//---------------------------------------------------------------------

#include <windows.h>
#include <math.h>
#include <float.h> //DBL_EPSILON

#include "filter.h"

#define MIN_WIDTH	32
#define MIN_HEIGHT	32
#define MAX_WIDTH	1920
#define MAX_HEIGHT	1080
#define MAX_CRIP	1024
#define MAX_SUBPX	100
#define MIN_PTS     2
#define MAX_PTS     10
#define FRM_FACTOR  1000

#define LANC_RAD 3.0

#ifndef PI
#define PI (atan(1)*4)
#endif

#define ID_TOP    0
#define ID_BOTTOM 1
#define ID_LEFT   2
#define ID_RIGHT  3

#define ID_TRACK_SWITCH  0
#define ID_TRACK_HFRM    1
#define ID_TRACK_LFRM    2
#define ID_TRACK_FRMGS   3
#define ID_TRACK_TOP     4
#define ID_TRACK_DT      5
#define ID_TRACK_BOTTOM  6
#define ID_TRACK_DB      7
#define ID_TRACK_LEFT    8
#define ID_TRACK_DL      9
#define ID_TRACK_RIGHT  10
#define ID_TRACK_DR     11
#define ID_TRACK_KAR    12
#define ID_TRACK_CTRL   13
#define ID_TRACK_WIDTH  14
#define ID_TRACK_HEIGHT 15

#define ID_CTRL_ADD  1
#define ID_CTRL_DEL -1
#define ID_CTRL_SET  1
#define ID_CTRL_GET -1


//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------

typedef struct {
	int    length;
	int    src;
	double clp;
	int    rst;
	double left;
	double right;
	int    width;
	int    height;
	int    tap;
	int    step;
	double factor;
	double scale;
	double support;
	int    **weight;
	int    **index;
} PARAMETER;

PARAMETER x_prm;
PARAMETER y_prm;


//---------------------------------------------------------------------
//		gf[^
//---------------------------------------------------------------------

// gf[^̓éAgbNo[̐ݒlƋɃvt@C(.cfgt@C)ɕۑ

typedef struct {
	int   frame;   // HFRM * FRM_FACTOR + LFRM
	int   clip[4]; // CLIP * MAX_SUBPX + DC
} SET_POINTS;

typedef struct {
	int        stp_n; //݂̐ݒ|Cg
	SET_POINTS stp[MAX_PTS+2];
} FILTER_SETTINGS;

FILTER_SETTINGS flt_stgs;

// flt_stgs.stp[0]        :framẻݒ
// flt_stgs.stp[1]        :擪̐ݒ|Cg
// flt_stgs.stp[flt_stgs.stp_n]  :̐ݒ|Cg
// flt_stgs.stp[flt_stgs.stp_n+1]:framȅݒ


//---------------------------------------------------------------------
//		function prototypes
//---------------------------------------------------------------------

static void set_clip_prms( FILTER *fp, FILTER_PROC_INFO *fpip, int frame);
static void horizontal_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm );
static void vertical_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm );
static void set_lanc_prms( PARAMETER *prm );
static double lanczos(double phase);

static void update_all_tracks(FILTER *fp);
static void setup_range(FILTER *fp, void *editp);
//static void setup_range_fileopen(FILTER *fp, void *editp);

static void proc_kar(FILTER *fp, int track, int mode);
static void proc_tr_kar(FILTER *fp, int mode);

static int opposite(int arg);
static int perpendicular(int arg, int mode);
static int track2tblr(int arg);
static int tblr2track_clip(int arg);
static int tblr2track_dc(int arg);


//---------------------------------------------------------------------
//		gbNo[ݒ
//---------------------------------------------------------------------

#define	TRACK_N	16 //gbNo[̐
TCHAR	*track_name[] =	{ //gbNo[̖O
		" SWITCH",
		"k frame","   frame",
		"GET/SET",
		"top"    ,"         dt",
		"bottom" ,"         db",
		"left"   ,"         dl",
		"right"  ,"         dr",
		"KARmode",
		"DEL/ADD",
		"width","height"
};
int		track_default[] = { //gbNo[̏l
	1,
	0,0,
	0,
	0,0,
	0,0,
	0,0,
	0,0,
	0,
	0,
	320,240
};
int		track_s[] = { //gbNo[̉l start
	1,
	0,0,
	ID_CTRL_GET,
	0,0,
	0,0,
	0,0,
	0,0,
	0,
	ID_CTRL_DEL,
	MIN_WIDTH,MIN_HEIGHT
};
int		track_e[] = { //gbNo[̏l end
	MIN_PTS,
	FRM_FACTOR, FRM_FACTOR-1,
	ID_CTRL_SET,
	MAX_CRIP,   MAX_SUBPX-1,
	MAX_CRIP,   MAX_SUBPX-1,
	MAX_CRIP,   MAX_SUBPX-1,
	MAX_CRIP,   MAX_SUBPX-1,
	4,
	ID_CTRL_ADD,
	MAX_WIDTH,  MAX_HEIGHT
};

#define CHECK_N 0 //`FbN{bNX̐


//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------

FILTER_DLL filter = {
	  FILTER_FLAG_EX_DATA           //gf[^ۑo悤ɂ܂
	| FILTER_FLAG_EX_INFORMATION    //tB^̊gݒł悤ɂ܂
	| FILTER_FLAG_WINDOW_THICKFRAME //TCYύX\ȃEBhE܂
	| FILTER_FLAG_WINDOW_SIZE,      //ݒEBhẼTCYwo悤ɂ܂
								//	tB^̃tO
	FILTER_WINDOW_SIZE_ADD | 0, FILTER_WINDOW_SIZE_ADD | 0,
								//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
								//	ݒl FILTER_WINDOW_SIZE_ADD ORĐݒ肷ƕW̃TCY̒ǉ̎wɂȂ܂
	"Nbvv03",			//	tB^̖O
	TRACK_N,					//	gbNo[̐
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL,						//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_update,				//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_WndProc,				//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	gbNo[̐ݒlSւ̃|C^ (AviUtlŐݒ肳܂)
	NULL,						//	`FbN{bNX̐ݒlSւ̃|C^ (AviUtlŐݒ肳܂)
	&flt_stgs,					//	gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	sizeof(flt_stgs),			//	gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"Nbv ver 0.3 by mer",
								//	tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	O֐e[uւ̃|C^ (AviUtlŐݒ肳܂)
	NULL,						//	EBhEnh (AviUtlŐݒ肳܂)
	NULL,						//	DLL̃CX^Xnh (AviUtlŐݒ肳܂)
	NULL,						//	gf[^̏lf[^̈ւ̃|C^ (NULLȂ珉܂)
	NULL,						//	C^[[XtB^ŕۑt[߂鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	vWFNgt@Cf[^ǂݍ񂾎ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	vWFNgt@CZ[uĂ鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	CEBhẼ^Cgo[\鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	PluginsfBNg̃TufBNgDLL鎞̂݁ATufBNg܂B
	NULL,						//	gpɗ\񂳂Ă܂BNULLɂĂB
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------

EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}


//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
 
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//	fp->track[n]			: gbNo[̐l
//	fp->check[n]			: `FbN{bNX̐l
//	fpip->w 				: ۂ̉摜̉
//	fpip->h 				: ۂ̉摜̏c
//	fpip->max_w				: 摜̈̉
//	fpip->max_h				: 摜̈̏c
//	fpip->ycp_edit			: 摜̈ւ̃|C^
//	fpip->ycp_temp			: e|̈ւ̃|C^
//	fpip->ycp_edit[n].y		: f(Px    )f[^ (     0 ` 4096 )
//	fpip->ycp_edit[n].cb	: f(F())f[^ ( -2048 ` 2048 )
//	fpip->ycp_edit[n].cr	: f(F())f[^ ( -2048 ` 2048 )
//  ff[^͔͈͊OɏoĂ邱Ƃ܂B
//  ܂͈͓Ɏ߂ȂĂ܂܂B
//	摜TCYςƂ fpip->w  fpip->h ς܂B
//	e|̈ɏ摜i[Ƃ
//	fpip->ycp_edit  fpip->ycp_temp ւ܂B
	
	PIXEL_YC *swap;
	
	set_clip_prms(fp, fpip, fpip->frame);
	
	/*  */
	
	horizontal_filter(fpip->ycp_edit, fpip->ycp_temp, &x_prm);
	
	swap = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = swap;
	fpip->w = fp->track[ID_TRACK_WIDTH];
	
	/* c */
	
	vertical_filter(fpip->ycp_edit, fpip->ycp_temp, &y_prm);
	
	swap = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = swap;
	fpip->h = fp->track[ID_TRACK_HEIGHT];
	
	return TRUE;
}


//---------------------------------------------------------------------
//		lanczosTCY
//---------------------------------------------------------------------

static void set_clip_prms( FILTER *fp, FILTER_PROC_INFO *fpip, int frame)
{
	double a[4], b[4], clip[4];
	const double d = 1.0/MAX_SUBPX;
	int former, latter;
	int i, n;
	
	if(	frame < flt_stgs.stp[1]             .frame ||
		frame > flt_stgs.stp[flt_stgs.stp_n].frame ){
		for(i=0; i<4; i++){
			clip[i] = 0.0;
		}
	}else{
		for(n=2; n<flt_stgs.stp_n+1; ++n){
			if( frame > flt_stgs.stp[n].frame){
				continue;
			}else{
				break;
			}
		}
		former = frame - flt_stgs.stp[n-1].frame;
		latter =         flt_stgs.stp[n]  .frame - frame;
		for(i=0; i<4; i++){
			a[i] = flt_stgs.stp[n-1].clip[i] * d * latter;
			b[i] = flt_stgs.stp[n]  .clip[i] * d * former;
			clip[i] = (a[i] + b[i]) / (former + latter);
		}
	}
	
	x_prm.src     = fpip->w;
	x_prm.clp     = x_prm.src - (clip[ID_LEFT] + clip[ID_RIGHT]);
	x_prm.rst     = fp->track[ID_TRACK_WIDTH];
	x_prm.factor  = x_prm.rst / x_prm.clp;                           //g嗦
	x_prm.scale   = (x_prm.factor < 1.0) ? x_prm.factor : 1.0; //min //src1ڐ̒(lanczos̓XP[)
	x_prm.support = LANC_RAD / x_prm.scale;                          //src̃f[^(Б)
	x_prm.tap     = (int)(2 * x_prm.support) + 1;                    //src̃f[^
	
	y_prm.src     = fpip->h;
	y_prm.clp     = y_prm.src - (clip[ID_TOP] + clip[ID_BOTTOM]);
	y_prm.rst     = fp->track[ID_TRACK_HEIGHT];
	y_prm.factor  = y_prm.rst / y_prm.clp;
	y_prm.scale   = (y_prm.factor < 1.0) ? y_prm.factor : 1.0; //min
	y_prm.support = LANC_RAD / y_prm.scale;
	y_prm.tap     = (int)(2 * y_prm.support) + 1;
	
	x_prm.left  = clip[ID_LEFT];
	x_prm.right = clip[ID_RIGHT];
	y_prm.left  = clip[ID_TOP];
	y_prm.right = clip[ID_BOTTOM];
	
	x_prm.width  = x_prm.rst; // not x_prm.src
	x_prm.height = y_prm.src; // not y_prm.rst
	
	y_prm.width  = x_prm.rst;
	y_prm.height = y_prm.rst;
	
	x_prm.step = fpip->max_w;
	y_prm.step = fpip->max_w;
}


static void horizontal_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm )
{
	int length = prm->rst;
	int tap    = prm->tap;
	int step   = prm->step;
	int **weight;
	int **index;
	
	int i, j, k;
	int luma, cb, cr;
	
	weight = (int **)malloc(sizeof(int *)*length);
	index  = (int **)malloc(sizeof(int *)*length);
	
	for(i=0;i<length;i++){
		weight[i] = (int *)malloc(sizeof(int)*tap);
		index[i]  = (int *)malloc(sizeof(int)*tap);
	}
	
	prm->weight = weight;
	prm->index  = index;
	
	set_lanc_prms(prm);
	
	for(i=0; i < prm->height; i++){ /* c[v */
		for(j=0; j < prm->width; j++){ /* [v */
			luma = 0;
			cb = 0;
			cr = 0;
			for(k=0; k < prm->tap; k++){
				luma += in[i*step+index[j][k]].y  * weight[j][k];
				cb   += in[i*step+index[j][k]].cb * weight[j][k];
				cr   += in[i*step+index[j][k]].cr * weight[j][k];
			}
			out[i*step+j].y  = (short)((luma + (1 << 15)) >> 16);
			out[i*step+j].cb = (short)((cb   + (1 << 15)) >> 16);
			out[i*step+j].cr = (short)((cr   + (1 << 15)) >> 16);
		}
	}
	
	for(i=0;i<length;i++){
		free(weight[i]);
		free(index[i]);
	}
	free(weight);
	free(index);
	
}


static void vertical_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm )
{
	int length = prm->rst;
	int tap    = prm->tap;
	int step   = prm->step;
	int **weight;
	int **index;
	
	int i, j, k;
	int luma, cb, cr;
	
	weight = (int **)malloc(sizeof(int *)*length);
	index  = (int **)malloc(sizeof(int *)*length);
	
	for(i=0;i<length;i++){
		weight[i] = (int *)malloc(sizeof(int)*tap);
		index[i]  = (int *)malloc(sizeof(int)*tap);
	}
	
	prm->weight = weight;
	prm->index  = index;
	
	set_lanc_prms(prm);
	
	for(i=0; i < prm->height; i++){ /* c[v */
		for(j=0; j < prm->width; j++){ /* [v */
			luma = 0;
			cb = 0;
			cr = 0;
			for(k=0; k < prm->tap; k++){
				luma += in[index[i][k]*step+j].y  * weight[i][k];
				cb   += in[index[i][k]*step+j].cb * weight[i][k];
				cr   += in[index[i][k]*step+j].cr * weight[i][k];
			}
			out[i*step+j].y  = (short)((luma + (1 << 15)) >> 16);
			out[i*step+j].cb = (short)((cb   + (1 << 15)) >> 16);
			out[i*step+j].cr = (short)((cr   + (1 << 15)) >> 16);
		}
	}
	
	for(i=0;i<length;i++){
		free(weight[i]);
		free(index[i]);
	}
	free(weight);
	free(index);
	
}


static void set_lanc_prms( PARAMETER *prm )
{
	int src = prm->src;
	int rst = prm->rst;
	int tap = prm->tap;
	double left = prm->left;
	double factor = prm->factor;   //g嗦
	double scale = prm->scale;     //src1ڐ̒(lanczos̓XP[)
	double support = prm->support; //src̃f[^(Б)
	int **weight = prm->weight;
	int **index = prm->index;

	int pos;
	double center, start;
	double sum;
	double distance;
	
	double *work;
	
	int x, n;
	
	work = (double *)malloc(sizeof(double)*tap);
	
	for(x=0; x<rst; ++x){
		center = (x + 0.5) / factor + left; //ݒn(srcXP[)
		start = center-support+0.5;
		pos = (int)((start > 0.0) ? start : 0.0); //X^[gʒuindex
		distance = pos - center +0.5; //(srcXP[)
		sum = 0.0;
		for(n=0; n<tap; ++n){
			index[x][n] = pos;
			work[n] = (pos < src) ? lanczos(distance * scale) : 0.0; //(lanczos̓XP[)
			sum += work[n];
			++pos;
			++distance;
		}
		for(n=0; n<tap; ++n){
			weight[x][n] = (int)((work[n] / sum) * (1<<16));
		}
	}
	
	free(work);
	
}


static double lanczos(double phase)
{
	double ret;
	
	if(fabs(phase) < DBL_EPSILON){
		return 1.0;
	}
	
	if(fabs(phase) >= LANC_RAD){
		return 0.0;
	}
	
	phase *= PI;
	ret = sin(phase) * sin(phase / LANC_RAD) / (phase * phase / LANC_RAD);
	
	return ret;
}


//---------------------------------------------------------------------
//		ݒ肪ύXꂽƂɌĂ΂֐
//---------------------------------------------------------------------

BOOL func_update( FILTER *fp,int status )
{
	const int track_n = status - FILTER_UPDATE_STATUS_TRACK;
	const int sw = fp->track[ID_TRACK_SWITCH];
	int temp;
	
	if(track_e[ID_TRACK_SWITCH] != flt_stgs.stp_n){
		//gf[^ɕۑłȂtrack[ID_TRACK_SWITCH]̍őlAƂɂ`FbNIxł`FbNI
		track_e[ID_TRACK_SWITCH] = flt_stgs.stp_n;
		fp->exfunc->filter_window_update(fp);
	}
	
	switch(track_n){
		case ID_TRACK_SWITCH:
			
			update_all_tracks(fp);
			
			fp->exfunc->filter_window_update(fp);
			return TRUE;
		case ID_TRACK_HFRM:
		case ID_TRACK_LFRM:
			temp = fp->track[ID_TRACK_HFRM] * FRM_FACTOR + fp->track[ID_TRACK_LFRM];
				if(temp >= flt_stgs.stp[sw+1].frame){ //1傫΁A-1
					temp = flt_stgs.stp[sw+1].frame - 1;
					fp->track[ID_TRACK_HFRM] = temp / FRM_FACTOR;
					fp->track[ID_TRACK_LFRM] = temp % FRM_FACTOR;
					fp->exfunc->filter_window_update(fp);
				}
				if(temp <= flt_stgs.stp[sw-1].frame){ //1O菬΁A+1
					temp = flt_stgs.stp[sw-1].frame + 1;
					fp->track[ID_TRACK_HFRM] = temp / FRM_FACTOR;
					fp->track[ID_TRACK_LFRM] = temp % FRM_FACTOR;
					fp->exfunc->filter_window_update(fp);
				}
			flt_stgs.stp[sw].frame = temp; // \̂ɕۑ
			return TRUE;
		case ID_TRACK_TOP:
			if(fp->track[ID_TRACK_TOP] + fp->track[ID_TRACK_BOTTOM] > track_e[ID_TRACK_TOP]){ // Nbvʐ
				fp->track[ID_TRACK_TOP] = track_e[ID_TRACK_TOP] - fp->track[ID_TRACK_BOTTOM];
				fp->exfunc->filter_window_update(fp);
			}
			/* FALLTHROUGH */
		case ID_TRACK_DT:
			if(fp->track[ID_TRACK_KAR]){ // AXyNgێ
				proc_kar(fp, ID_TRACK_TOP, fp->track[ID_TRACK_KAR]);
				fp->exfunc->filter_window_update(fp);
			}
			flt_stgs.stp[sw].clip[ID_TOP] = fp->track[ID_TRACK_TOP] * MAX_SUBPX + fp->track[ID_TRACK_DT]; // \̂ɕۑ
			return TRUE;
		case ID_TRACK_BOTTOM:
			if(fp->track[ID_TRACK_BOTTOM] + fp->track[ID_TRACK_TOP] > track_e[ID_TRACK_BOTTOM]){ // Nbvʐ
				fp->track[ID_TRACK_BOTTOM] = track_e[ID_TRACK_BOTTOM] - fp->track[ID_TRACK_TOP];
				fp->exfunc->filter_window_update(fp);
			}
			/* FALLTHROUGH */
		case ID_TRACK_DB:
			if(fp->track[ID_TRACK_KAR]){ // AXyNgێ
				proc_kar(fp, ID_TRACK_BOTTOM, fp->track[ID_TRACK_KAR]);
				fp->exfunc->filter_window_update(fp);
			}
			flt_stgs.stp[sw].clip[ID_BOTTOM] = fp->track[ID_TRACK_BOTTOM] * MAX_SUBPX + fp->track[ID_TRACK_DB]; // \̂ɕۑ
			return TRUE;
		case ID_TRACK_LEFT:
			if(fp->track[ID_TRACK_LEFT] + fp->track[ID_TRACK_RIGHT] > track_e[ID_TRACK_LEFT]){ // Nbvʐ
				fp->track[ID_TRACK_LEFT] = track_e[ID_TRACK_LEFT] - fp->track[ID_TRACK_RIGHT];
				fp->exfunc->filter_window_update(fp);
			}
			/* FALLTHROUGH */
		case ID_TRACK_DL:
			if(fp->track[ID_TRACK_KAR]){ // AXyNgێ
				proc_kar(fp, ID_TRACK_LEFT, fp->track[ID_TRACK_KAR]);
				fp->exfunc->filter_window_update(fp);
			}
			flt_stgs.stp[sw].clip[ID_LEFT] = fp->track[ID_TRACK_LEFT] * MAX_SUBPX + fp->track[ID_TRACK_DL]; // \̂ɕۑ
			return TRUE;
		case ID_TRACK_RIGHT:
			if(fp->track[ID_TRACK_RIGHT] + fp->track[ID_TRACK_LEFT] > track_e[ID_TRACK_RIGHT]){ // Nbvʐ
				fp->track[ID_TRACK_RIGHT] = track_e[ID_TRACK_RIGHT] - fp->track[ID_TRACK_LEFT];
				fp->exfunc->filter_window_update(fp);
			}
			/* FALLTHROUGH */
		case ID_TRACK_DR:
			if(fp->track[ID_TRACK_KAR]){ // AXyNgێ
				proc_kar(fp, ID_TRACK_RIGHT, fp->track[ID_TRACK_KAR]);
				fp->exfunc->filter_window_update(fp);
			}
			flt_stgs.stp[sw].clip[ID_RIGHT] = fp->track[ID_TRACK_RIGHT] * MAX_SUBPX + fp->track[ID_TRACK_DR]; // \̂ɕۑ
			return TRUE;
		case ID_TRACK_KAR:
			if(fp->track[ID_TRACK_KAR]){ // 0łȂon Ȃ
				proc_tr_kar(fp, fp->track[ID_TRACK_KAR]);
				fp->exfunc->filter_window_update(fp);
			}
			return TRUE;
		case ID_TRACK_CTRL:
			switch(fp->track[ID_TRACK_CTRL]){
				int i;
				case ID_CTRL_ADD: //݂̈ʒǔɒǉ
					if(	flt_stgs.stp_n < MAX_PTS && // ܂󂫂Ȃ
						flt_stgs.stp[sw].frame + 1 < flt_stgs.stp[sw+1].frame )
					{
						flt_stgs.stp_n += 1; //ݒ|Cg̐CNg
						for(i=flt_stgs.stp_n+1; i>sw; --i){ //f[^炷
							flt_stgs.stp[i] = flt_stgs.stp[i-1];
						}
						track_e[ID_TRACK_SWITCH] = flt_stgs.stp_n; //gbNo[̍őlύX
						fp->track[ID_TRACK_SWITCH] += 1; //Vݒ|CgɈړ
						flt_stgs.stp[ fp->track[ID_TRACK_SWITCH] ].frame += 1;
						
						update_all_tracks(fp);
					}
					fp->track[ID_TRACK_CTRL] = 0;
					fp->exfunc->filter_window_update(fp);
					return TRUE;
				case ID_CTRL_DEL: //݂̈ʒu폜
					if(flt_stgs.stp_n > MIN_PTS){ //܂点Ȃ
						for(i=sw; i<flt_stgs.stp_n+1; ++i){ //f[^炷
							flt_stgs.stp[i] = flt_stgs.stp[i+1];
						}
						if(fp->track[ID_TRACK_SWITCH] == flt_stgs.stp_n){ //̐ݒ|CgȂAO
							fp->track[ID_TRACK_SWITCH] -= 1;
						}
						
						update_all_tracks(fp);
						
						flt_stgs.stp_n -= 1; //ݒ|Cg̐fNg
						track_e[ID_TRACK_SWITCH] = flt_stgs.stp_n; //gbNo[̍őlύX
					}
					fp->track[ID_TRACK_CTRL] = 0;
					fp->exfunc->filter_window_update(fp);
					return TRUE;
			}
			return TRUE;
		case ID_TRACK_WIDTH:
			return TRUE;
		case ID_TRACK_HEIGHT:
			return TRUE;
			
	}
	
	return FALSE;
	
}


static void update_all_tracks(FILTER *fp)
{
	const int sw = fp->track[ID_TRACK_SWITCH];
	
	fp->track[ID_TRACK_HFRM]   = flt_stgs.stp[sw].frame / FRM_FACTOR;
	fp->track[ID_TRACK_LFRM]   = flt_stgs.stp[sw].frame % FRM_FACTOR;
	fp->track[ID_TRACK_TOP]    = flt_stgs.stp[sw].clip[ID_TOP]    / MAX_SUBPX;
	fp->track[ID_TRACK_BOTTOM] = flt_stgs.stp[sw].clip[ID_BOTTOM] / MAX_SUBPX;
	fp->track[ID_TRACK_LEFT]   = flt_stgs.stp[sw].clip[ID_LEFT]   / MAX_SUBPX;
	fp->track[ID_TRACK_RIGHT]  = flt_stgs.stp[sw].clip[ID_RIGHT]  / MAX_SUBPX;
	fp->track[ID_TRACK_DT]     = flt_stgs.stp[sw].clip[ID_TOP]    % MAX_SUBPX;
	fp->track[ID_TRACK_DB]     = flt_stgs.stp[sw].clip[ID_BOTTOM] % MAX_SUBPX;
	fp->track[ID_TRACK_DL]     = flt_stgs.stp[sw].clip[ID_LEFT]   % MAX_SUBPX;
	fp->track[ID_TRACK_DR]     = flt_stgs.stp[sw].clip[ID_RIGHT]  % MAX_SUBPX;
}


//---------------------------------------------------------------------
//		KAR : Keep Aspect Ratio@AXyNgێ
//---------------------------------------------------------------------

static void proc_kar(FILTER *fp, int track, int mode)
{
// KAR on ̎ɃgbNo[A
	int arg; // argument               prl
	int prl; // parallel      ̂̔     prl_ops
	int ppd; // perpendicular        ppd
	int ops; // opposite      ̂̔ ppd_ops
	int prl_len, ppd_len;
	double clip[4];
	const double d = 1.0/MAX_SUBPX;
	const int sw = fp->track[ID_TRACK_SWITCH];
	
	if( x_prm.src * y_prm.src ){ // ǂ0łȂȂ
		clip[ID_TOP]    = fp->track[ID_TRACK_TOP]    + fp->track[ID_TRACK_DT] * d;
		clip[ID_BOTTOM] = fp->track[ID_TRACK_BOTTOM] + fp->track[ID_TRACK_DB] * d;
		clip[ID_LEFT]   = fp->track[ID_TRACK_LEFT]   + fp->track[ID_TRACK_DL] * d;
		clip[ID_RIGHT]  = fp->track[ID_TRACK_RIGHT]  + fp->track[ID_TRACK_DR] * d;
		
		arg = track2tblr(track);
		prl = opposite(arg);
		ppd = perpendicular(arg, mode);
		ops = opposite(ppd);
		switch(arg){ // č
			case ID_TOP:
			case ID_BOTTOM:
				prl_len = y_prm.src;
				ppd_len = x_prm.src;
				break;
			case ID_LEFT:
			case ID_RIGHT:
				prl_len = x_prm.src;
				ppd_len = y_prm.src;
				break;
		}
		
		clip[ppd]  = clip[arg] + clip[prl]; // prl̘a
		clip[ppd] *= ppd_len;               // ppd̒|
		clip[ppd] /= prl_len;               // prl̒Ŋ
		clip[ppd] -= clip[ops];             // ops
		clip[ppd] += d * 0.5; // ľܓ
		
		if(clip[ppd] < 0.0){ // ̒lɂȂĂ܂Ȃ
			int ppd_tmp = perpendicular(ppd, mode); // ppdppdprl
			int ops_tmp = opposite(ppd_tmp);
			clip[ppd] = 0.0;
			clip[ppd_tmp] = clip[ppd] + clip[ops];
			clip[ppd_tmp] *= prl_len; // čtɂȂ
			clip[ppd_tmp] /= ppd_len;
			clip[ppd_tmp] -= clip[ops_tmp];
			clip[ppd_tmp] += d * 0.5; // ľܓ
			fp->track[tblr2track_clip(ppd_tmp)] = (int)( clip[ppd_tmp] );
			fp->track[tblr2track_dc(ppd_tmp)]   = (int)( ( clip[ppd_tmp]-(int)(clip[ppd_tmp]) ) * MAX_SUBPX );
			flt_stgs.stp[sw].clip[ppd_tmp] = fp->track[tblr2track_clip(ppd_tmp)] * MAX_SUBPX + fp->track[tblr2track_dc(ppd_tmp)];
		}
		
		fp->track[tblr2track_clip(ppd)] = (int)( clip[ppd] );
		fp->track[tblr2track_dc(ppd)]  = (int)( ( clip[ppd]-(int)(clip[ppd]) ) * MAX_SUBPX );
		flt_stgs.stp[sw].clip[ppd] = fp->track[tblr2track_clip(ppd)] * MAX_SUBPX + fp->track[tblr2track_dc(ppd)];
	}
}


static void proc_tr_kar(FILTER *fp, int mode)
{
//KAR modeύXꂽ̏
	int arg, prl, ppd, ops;
	int prl_len, ppd_len;
	double clip[4];
	double x, y;
	const double d = 1.0/MAX_SUBPX;
	const int sw = fp->track[ID_TRACK_SWITCH];
	
	if( x_prm.src * y_prm.src ){ // ǂ0łȂȂ
		clip[ID_TOP]    = fp->track[ID_TRACK_TOP]    + fp->track[ID_TRACK_DT] * d;
		clip[ID_BOTTOM] = fp->track[ID_TRACK_BOTTOM] + fp->track[ID_TRACK_DB] * d;
		clip[ID_LEFT]   = fp->track[ID_TRACK_LEFT]   + fp->track[ID_TRACK_DL] * d;
		clip[ID_RIGHT]  = fp->track[ID_TRACK_RIGHT]  + fp->track[ID_TRACK_DR] * d;
		
		x = (clip[ID_LEFT] + clip[ID_RIGHT] ) * y_prm.src;
		y = (clip[ID_TOP]  + clip[ID_BOTTOM]) * x_prm.src;
		
		if(x>y){ // ɍ肷ĂȂ
			arg = ID_LEFT; // ύXƂɂ
			prl = opposite(arg);
			ppd = perpendicular(arg, mode);
			ops = opposite(ppd);
			prl_len = x_prm.src;
			ppd_len = y_prm.src; // c
		}else{ // łȂȂ
			arg = ID_TOP; // cύXƂɂ
			prl = opposite(arg);
			ppd = perpendicular(arg, mode);
			ops = opposite(ppd);
			prl_len = y_prm.src;
			ppd_len = x_prm.src; // 
		}
		
		// ȉAproc_karƓ
		clip[ppd]  = clip[arg] + clip[prl];
		clip[ppd] *= ppd_len;
		clip[ppd] /= prl_len;
		clip[ppd] -= clip[ops];
		clip[ppd] += d * 0.5; // ľܓ
		fp->track[tblr2track_clip(ppd)] = (int)( clip[ppd] );
		fp->track[tblr2track_dc(ppd)]  = (int)( ( clip[ppd]-(int)(clip[ppd]) ) * MAX_SUBPX );
		flt_stgs.stp[sw].clip[ppd] = fp->track[tblr2track_clip(ppd)] * MAX_SUBPX + fp->track[tblr2track_dc(ppd)];
	}
}


//---------------------------------------------------------------------
//		enumIG֐
//---------------------------------------------------------------------

static int opposite(int arg)
{
	switch(arg){
		case ID_TOP:
			return ID_BOTTOM;
		case ID_BOTTOM:
			return ID_TOP;
		case ID_LEFT:
			return ID_RIGHT;
		case ID_RIGHT:
			return ID_LEFT;
	}
}


static int perpendicular(int arg, int mode)
{
	const static int table[2][4] = 
		{	// LB, RB, LT, RT
			{ ID_BOTTOM, ID_BOTTOM, ID_TOP , ID_TOP   },
			{ ID_LEFT  , ID_RIGHT , ID_LEFT, ID_RIGHT }
		};
	
	switch(arg){
		case ID_TOP:
		case ID_BOTTOM:
			return table[1][mode-1];
		case ID_LEFT:
		case ID_RIGHT:
			return table[0][mode-1];
	}
}


static int track2tblr(int arg)
{
	switch(arg){
		case ID_TRACK_TOP:
		case ID_TRACK_DT:
			return ID_TOP;
		case ID_TRACK_BOTTOM:
		case ID_TRACK_DB:
			return ID_BOTTOM;
		case ID_TRACK_LEFT:
		case ID_TRACK_DL:
			return ID_LEFT;
		case ID_TRACK_RIGHT:
		case ID_TRACK_DR:
			return ID_RIGHT;
	}
}


static int tblr2track_clip(int arg)
{
	switch(arg){
		case ID_TOP:
			return ID_TRACK_TOP;
		case ID_BOTTOM:
			return ID_TRACK_BOTTOM;
		case ID_LEFT:
			return ID_TRACK_LEFT;
		case ID_RIGHT:
			return ID_TRACK_RIGHT;
	}
}


static int tblr2track_dc(int arg)
{
	switch(arg){
		case ID_TOP:
			return ID_TRACK_DT;
		case ID_BOTTOM:
			return ID_TRACK_DB;
		case ID_LEFT:
			return ID_TRACK_DL;
		case ID_RIGHT:
			return ID_TRACK_DR;
	}
}


//---------------------------------------------------------------------
//		ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------

BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	// vt@Cǂݍ񂾒ɑ郁bZ[W͉낤H
	// WM_FILTER_UPDATEHWM_FILTER_CHANGE_PARAMH
	
	switch(message){
		case WM_FILTER_INIT: //Jnɑ܂
			setup_range(fp, editp);
			return TRUE;
		case WM_FILTER_FILE_OPEN: //ҏWt@CI[vꂽɑ܂
			fp->exfunc->get_frame_size(editp, &x_prm.src, &y_prm.src);
			return TRUE;
		case WM_FILTER_CHANGE_PARAM: //̃tB^̐ݒ肪ύXꂽɑ܂
			switch(fp->track[ID_TRACK_FRMGS]){
				case ID_CTRL_GET:
					if( fp->exfunc->get_frame_n( editp ) ){
						int frame = fp->exfunc->get_frame(editp);
						int sw = fp->track[ID_TRACK_SWITCH];
						
						if(frame >= flt_stgs.stp[sw+1].frame){
							frame = flt_stgs.stp[sw+1].frame - 1;
						}
						if(frame <= flt_stgs.stp[sw-1].frame){
							frame = flt_stgs.stp[sw-1].frame + 1;
						}
						fp->track[ID_TRACK_HFRM] = frame / FRM_FACTOR;
						fp->track[ID_TRACK_LFRM] = frame % FRM_FACTOR;
						flt_stgs.stp[sw].frame = frame;
					}
					fp->track[ID_TRACK_FRMGS] = 0;
					fp->exfunc->filter_window_update(fp);
					return TRUE;
				case ID_CTRL_SET:
					fp->exfunc->set_frame(editp, flt_stgs.stp[ fp->track[ID_TRACK_SWITCH] ].frame);
					fp->track[ID_TRACK_FRMGS] = 0;
					fp->exfunc->filter_window_update(fp);
					return TRUE;
			}
			return FALSE;
/*****
		case WM_FILTER_FILE_OPEN: //ҏWt@CI[vꂽɑ܂
			setup_range_fileopen(fp, editp);
			return TRUE;
*****/
/*****
		// ̕ƁAAviUtl{̂Nɍvo܂܌ł܂
		// func_update̐擪ֈړ
		case WM_FILTER_UPDATE: //etB^ݒҏWeύXꂽɑ܂
			track_e[ID_TRACK_SWITCH] = flt_stgs.stp_n;
			return TRUE;
*****/
	}
	return FALSE;
	
}


static void setup_range(FILTER *fp, void *editp)
{
	SYS_INFO si;
	
	if(fp->exfunc->get_sys_info){
		fp->exfunc->get_sys_info(editp, &si);
		
		if(!flt_stgs.stp_n){
			flt_stgs.stp_n = MIN_PTS;
			flt_stgs.stp[0]               .frame = -1;
			flt_stgs.stp[flt_stgs.stp_n]  .frame = si.max_frame;
			flt_stgs.stp[flt_stgs.stp_n+1].frame = si.max_frame + 1;
		}
		
		track_e[ID_TRACK_SWITCH] = flt_stgs.stp_n;
		
		track_e[ID_TRACK_HFRM]   = si.max_frame / FRM_FACTOR;
		
		track_e[ID_TRACK_TOP]    = si.max_h - 3;
		track_e[ID_TRACK_BOTTOM] = si.max_h - 3;
		track_e[ID_TRACK_LEFT]   = si.max_w - 3;
		track_e[ID_TRACK_RIGHT]  = si.max_w - 3;
		
		track_s[ID_TRACK_WIDTH]  = si.min_w;
		track_s[ID_TRACK_HEIGHT] = si.min_h;
		
		track_e[ID_TRACK_WIDTH]  = si.max_w;
		track_e[ID_TRACK_HEIGHT] = si.max_h;
		
		fp->exfunc->filter_window_update(fp);
	}
}

/*****
static void setup_range_fileopen(FILTER *fp, void *editp)
{
	int w, h;
	
	if( fp->exfunc->get_frame_size(editp, &w, &h) ){
		track_e[ID_TRACK_TOP]    = h - 3;
		track_e[ID_TRACK_BOTTOM] = h - 3;
		track_e[ID_TRACK_LEFT]   = w - 3;
		track_e[ID_TRACK_RIGHT]  = w - 3;
		
		fp->track[ID_TRACK_WIDTH]  = w;
		fp->track[ID_TRACK_HEIGHT] = h;
	}
	fp->exfunc->filter_window_update(fp);
}
*****/

